function v=bsm_objectiveFunction(M,x,c)
% function v=bsm_objectiveFunction(M,x,c)
% Choose what functional to optimize.

%v = norm(M*x-c)+0.1*inhomogenity(x);
v = norm(M*x-c)*inhomogenity(x);
%v = norm(M*x-c);

end


function x=inhomogenity(x)
% The sum of all elements consisting of edges detected by morpological
% operations

p=sqrt(numel(x));
x=reshape(x,p,p);
se=strel('square',3);
edges=x-imerode(x,se); %Edge detection
x=sum(sum(edges));
end